Subject: Re: Implementation of modifying VC change comments for Git

From: Eli Zaretskii <[email-masked]>
Date: Tue, 22 Oct 2024 16:27:56 +0300

> From: Sean Whitton <[email-masked]>
> Cc: [email-masked],  [email-masked],  [email-masked]
> Date: Tue, 22 Oct 2024 16:25:52 +0800
> 
> > At this point "git log" shows a revision with my amended log message
> > (let's call this AMENDED-REV), followed by the revision with the
> > original log message (let's call it ORIG-REV).  So my Git command
> > looks like this:
> >
> >   git rebase --autosquash -i ORIG-REV~1
> >
> > After this step, I see this in the editor (where I indented the text
> > by 2 columns):
> >
> >   pick bf73d7e Foobar with some Unicode אבגד ą ě č
> >   # pick bc3c567b2b136d040fd13373b6594c1ec026fec6 Foobar with some Unicode אבגד ą ě č
> 
> There are two things about this output that are unexpected to me:
> 
> - The first line of the AMENDED-REV message does not appear to start
>   with "amend!".  I thought that you confirmed in a previous message
>   that the commit messsage of AMENDED-REV did have this structure:
> 
>     amend! <ORIG-REV sha1>
> 
>     <AMENDED-REV amended message>

It isn't there because you didn't tell me to include it.  The original
commit was lost when I tried to perform the steps the previous time,
so I had to reproduce it, and I used the last part of this step to
produce it:

> So, please use the debugging version of my patch to create the special
> "amend!" commit again, or use the one from yesterday if you still have
> it, or you could manually create it by passing --allow-empty to 'git
> commit'.

IOW, I "manually created it by passing --allow-empty to 'git commit'",
but since you didn't say what log message to give, I used just some
random text, and it didn't include "amend!".  If the log message I use
in this step must have some specific structure or content, please give
more detailed instructions.

> - The line for the AMENDED-REV message is commented out.  That means
>   that git-rebase proposes to drop the commit.  I would guess that git
>   wants to drop it because it introduces no content changes.
> 
> > Does this mean it didn't work? or did I misinterpret the steps?
> 
> I think that there are two possibilities.  If you lost the magic
> "amend!" commit then please try again with an AMENDED-REV whose commit
> message has the special "amend!" structure.

I will, once you give the detailed instructions for how to do it from
the shell prompt.

> You can create one manually by passing --allow-empty to git-commit, or
> you can use the previous version of my patch with everything except the
> call to git-commit commented out -- here's the diff doing the
> commenting-out again, if you need it.

The diff no longer applies to the current master.  And I prefer doing
that manually anyway.  So let's have those instructions in full
detail.

Thanks.